
                    Speed and other important issues
                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Well, you can be happy, since this is definitely the FASTEST
UNARJ.TTP-depacker on the ST series. (Every depacker we could locate showed
ratings which differed by at least a factor 1.5 so it's advisable to kill
those if you have this one. We support all regular UNARJ.TTP-options
(except Security Envelope, which isnot supported by any other tool we know
of. (Except the original ARJ.EXE))

If you have had the pleasure to meet our previous releases (UNARJ230,
UNARJ241 and UNARJ990), you'll be very pleased to hear we are pushing those
right off the road:

Speed test with 2-volume ARJ test file:

(depacking speed is very dependent on harddisk and OS speed; for this test
a Siemens MEGAFILE 250 is used (seek time 22ms, data speed 470kB/s))

                         testing:            depacking:
UNARJ 2.30 (rev. IA1)  |  2:18.00       |       4:14.00
UNARJ 9.92 (rev. 2.023)|  0:38.22       |       2:18:00
speed factor:          |      3.6       |           1.8

In fact, this thing is a complete rewrite which shares no code with the
original UNARJ230 versions which came from Insh_Allah's hand. Mr Ni! from
the TOS crew has optimized the decompression routines severely; I believe
we are the fastest ARJ-decompressor around at the time of this writing...

Unfortunately the depacker has grown another 20K but I think that won't
hurt all you HD-users. In exchange for this extra 20K code you have the
complete manual inside the .TTP (Still there are a lot of cocksuckers that
dare to copy the executables without adding the proper documentation which
was supplied with the original: this way you can derive the documentation
every time again and again!) If you want a smaller executable (lunatic or
disk-only user) we have a Junior Version available in which we cut down on
the options-palette for both German & English lunatic/disk-only users.
Please note that the German version may contain even more typo's and other
editorial-related bugs/errors/features than the English version, since the
German language isn't our native language. (We only included it since
Germans seem to suffer from a sufficient understanding of English.) (For
French people: recompile with -DLANGUAGE=FRENCH ;-))Additional note:
manual-writers are herewith invited to redesign and rewrite the complete
documentation so it will become a decent manual/reference.


       Some crap about copyright, warez and all that sort of shit
       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

This package (ARJ*.*) is mind-warez (You should at least feel guilty when
you don't send us a message or a postcard). Everything you do or don't is
your own problem: blowing fuzes and melting Atari computers are not
included in the insurance policy. Anything else is neither. (You may praise
who/what-ever you believe in when you get this to work ;-)))

However we feel 'backing up your system before installing UNARJ' would be a
bit overdone... Sources for this thing are available on request: we (both
Mr Ni! and myself) invested a lot of time in this product so we would
appriciate any donations (needn't be money, though! Extra processing
power/devices are welcomed too!) in exchange for the complete C/ASM-source
release. (Just write us a note when you're interested)


                        Future developments
                        ~~~~~~~~~~~~~~~~~~~
                      (ARJ 9.9xxá development)

At the moment our biggest problem is the design of the various ARJ
compression modes. We only have access to some C-source for the depacker as
distributed by Robert K Jung, however we have implemented mode 4 (FAST)
compression anyway. Huffman additions (Mode 1-3) will have to wait a little
while for us to get the inspiration to do it... At the moment we can't say
anything more about expected compression speed & ratio's so you'll have to
wait for that release (which would develop quite a bit faster if we could
get our hands on some C/ASM/Pascal(?! yuck!) source. (If you have a
ARJ-archiver-source written in APL or any other language we would be happy
to learn the language anyway ;-))) This is an Alpha-release since we
haven't had the time to check all options extensively. Besides, we like to
keep this a non-final version until it can be distributed with our
ARJ10.00à. If you find anything which doesn't match our documentation,
please notify us through our contact addresses, email or support BBS in The
Netherlands (MBH BBS, for telephone number and e-mail adresses see the end
of the document); we will try to fix any problems a.s.a.p.

This distribution is dedicated to:

            ALL VIRGINAL HARDDISKS OUT THERE

            (unarj x -r~xd \*.ARJ    was made for you, my dear!)


                     Redirection issues
                     ~~~~~~~~~~~~~~~~~~

If you peeked at the commandline options, you'd sure seen the 'redirection'
text there: many people start to tremble when they see this: Will my marv'
shell be put out of bizz?! No! If you run a shell or anything that takes
over redirection (by parsing our commandline first!) we won't see the
redirection commands given, thus allowing the system to have it it's own
way. You should however note the fact that we don't differentiate between
STDOUT and STDERR in that case! (Well.... hm.... we do write STDOUT to
GEMDOS handle 1 (stdout) while STDERR is sent to GEMDOS handle -1
(non-redirectable (they say ;-)) stdout) This is not so much a bug
introduced by us as it is a system-wide problem: TOS hasn't ever had a
seperate stderr channel as has UNIX. So the risk is high you will redirect
both out STDOUT *and* STDERR messages when redirecting using your fave
commandline shell. Here are the 'undocumented features (now documented
;-))' that touch the redirection issue:

* STDOUT and STDERR will most probably not be recognized as seperate output
  streams when redirecting.

* Keypress requests and all that sort of shit is NOT (repeat: NOT!)
  suppressed when the system takes over redirection: we don't have a
  method included (yet) to recognize external redirection. Therefore you
  should use the appropriate command-options to disable every possible
  request done by UNARJ.TTP

* Redirection used with TOS-versions before 1.4 could very well fail. (As
  it would with other toolz)

If you use UNARJ's internal redirection routines however, there's a
difference between STDOUT and STDERR. Also we will message you about the
fact that output is redirected: most novice users get the shivers when they
don't see screen-output for more than five minutes... If redirection
attempts fail, you will be told about that fact too! 4DOS users will have
noticed we use the 4DOS way of redirecting STDERR ('>&') instead of the
UNIX way ('2>'). If you don't like it: don't use it.


                            Environment
                            ~~~~~~~~~~~

UNARJ.TTP will first look for an environment variable named ARJ_SW and use
its value as switch options for UNARJ.TTP. You can inhibit UNARJ.TTP from
using this environment variable by using the "-+" option. You can also set
the name of the environment variable with the "-+" option as in UNARJ.TTP x
-+ARJCFG archive.

Use some environment editing/setting tool to create an environment on your
Atari. (Most shells could use some script-file or seperate command to do
it...)

  SET ARJ_SW=<switches>

Example:  SET ARJ_SW=-~arj- -jy+ -~k -e -v+ -~acv

Do NOT add any blanks after the variable name ARJ_SW. As in LHARC, command
line switches can be selected to override ARJ_SW settings. UNARJ.TTP will
allow you to use a different switch character "-" or "/" in ARJ_SW and in
the command line.

If the ARJ_SW environment variable specifies a filename (text not beginning
with a switch character), UNARJ.TTP will open that filename and scan it
looking for a line of text that begins in column 1 with the same letter as
the UNARJ.TTP command being executed. The following text is processed as
the ARJ_SW switches. This allows each UNARJ.TTP command to have its own
switch settings. In addition, UNARJ.TTP will also look for the "+" (plus)
symbol in column 1 to use as a miscellaneous switch string.

This string will be added to any command switch string found if any. If no
command switch string is found, UNARJ.TTP will use the miscellaneous switch
string as the ARJ_SW switch settings. NOTE that the "+" switch settings
will NOT be usedif the "+" string occurs below the command switch string.
Please note that we included the <-~ac> ('Assume Command') option for this
'+' line specially! This way you are able to specify default behaviour of
UNARJ (even when in complete ARJ compatibility mode(<-~arj>))

The ARJ_SW variable or the ARJ_SW configuration file switch settings may
*have* quoted switches such as "-vasformat a:". This is opposite to the
ARJ.EXE conditions.


                         Commandline usage
                         ~~~~~~~~~~~~~~~~~

The only thing that has been and will be a constant factor for UNARJxxx.TTP
from the authors Insh_Allah/Mr Ni! is the ARGV & xArg support. Anybody
using TeraDesk (from W. Klaren of the TOS-Crew) or TOS 2.xx or above can
install UNARJ.TTP with an option list. (Install Application). Be sure to
change this if it was previously set up for UNARJ230 or older versions,
since our commandline options have changed significantly.As a bonus, ICONS
(ARJ_ICNS.RSC, ARJ_ICNS.H) is included in this distribution for use with
the 'TeringDesk' ICON.RSC file: use some RSC-editor to include these icons
in your collection. When you want this tool to depack your UNARJ.TTP
archives to a seperate directory each, you could specify

  x -rayv+ -~g %f h:\unarjed\

as the Teradesk 'Install application' commandline.

For those among you that learned to live with the absolutely weird options
contained in UNARJ210/220/230 there's yet another major change: from today
we will be ARJ.EXE (from R.K. Jung) compatible at all levels. However there
are some discrepancies here:

* added options for ST users. (-~___ shifted switch options)

* toggle-behaviour of ARJ.EXE is NOT emulated to the extend of toggling by
  multiple occurences of (Example:) -ja command-options. We do support
  -ja-/-ja+ toggling, but <-ja -ja> will NOT reset the  <-ja> option flags
  as ARJ.EXE would do, since <-ja> is treated equal to <-ja+> inside
  UNARJ241.TTP.

* very strict checking when using multiple volumes: ARJ.EXE only checks the
  time-stamp and verifies the file-size (which *should* *be* *large*
  *enough*) where UNARJ241.TTP does the same, except it will issue a
  warning when the existing part of a multiple-volume file is found to be
  larger than requested. This habit is better in most circumstances (as we
  view it) but fails when multiple volumes were created by ARJ.EXE using
  TEXT-mode (<-t1>, <-t1f>, <-t1g>): ARJ.EXE switches back to binary mode
  for the second part of the split-vol file while keeping the file-offset
  *value*. (for technical oriented people: ARJ.EXE uses stdio/stdlib
  fwrite() and fseek() which will behave different for TEXT & BINARY mode:
  file-offsets differ!)

* directory-recognition is a bit worse: directories MUST be terminated by a
  \ to be recognized as such: this alpha-release does not yet contain code
  to check if the specified path ends with a directory- or filename. This
  is true for both UNARJ.TTP-source-specification and basedir-spec.


                           Changes & Updates
                           ~~~~~~~~~~~~~~~~~

Changes and updates to (UN)ARJ.TTP and the files distributed with UNARJ.TTP
will be listed in the file CHANGES.LOG. This file will list changes at both
user-level (added options and changed behaviour) and technical level (bugs
and changes in the code for the technically minded). I (Insh_Allah) hope
the information contained in the files CHANGES.LOG, this file (HISTORY.TXT)
and the redirected manuals, extracted from UNARJ*.TTP, UNARJ*.TXT, will
enable you to use UNARJ to the full extent of its possibilities.

The newest version of this package is available at the following places:
  ARJ-support sites:
  ~~~~~~~~~~~~~~~~~

The newest version of this package is available at the following places:

World headquaters:  M()ir Brandts Honk BBS    (TOS-crew world HQ):
                    +31-70-3457929 / +31-70-3401215 / +31-070-3452981

Czech Republic:     CalamuSTation BBS:
                    +42-2-731120 (22:00 - 8:00)

Netherlands:        68000 data server BBS:
                    +31-53-777522

And the following internet sites:

  ftp.uni-stuttgart.de

  ftp.uni-regensburg.de

  atari.archive.umich.edu

If you discover problems, bugs or get the feeling you need some addition to
it (user-request), don't hesitate and mail us. If you want to mail us via
MBH, please mail Mr Ni! or Insh_Allah. If you have problems getting answers
from us, it could be that we once again didn't log in for over a month as
we will probably be submerged in the coding sea. In that case, ring the MBH
Sysop -[TJS]- or yell for the Atari-co-Sysop Chipswinger, as they both can
tell you how to contact us.Real urgent stuff (or when you just want to make
sure your stuff will reach our eyes) just write us a letter or a postcard
to one of the following addresses:

Hans Wessels
Rohofstraat 116
7604 AK   Almelo
The Netherlands
e-mail: mr_ni@mbh.org
        mr_ni@mst.tn.utwente.nl

or:

Insh_Allah
Wierdensestraat 78
7604 BK   Almelo
The Netherlands
e-mail: i_a@mbh.org

May the Power in the Clouds be guiding your path!

We hope you like this new UNARJ package for its speed and its versatility.
Furthermore we hope to have ARJ (ST) ready for you a.s.a.p. Meanwhile; have
phun using UNARJ9.96à for Atari ST/e/TT/Falcon. Standard options and
commands have been checked and no bugs were found on:

Atari ST (TOS 1.4) (1MB / 2.5MB / 4MB)
Atari ST (Kaos TOS 1.4.2) (1MB / 2.5MB / 4MB)
Atari ST (Kaos TOS 1.4.2) (1MB / 2.5MB / 4MB) (HBS240)
Atari TT (TOS 3.0x) (2 MB)
Atari TT (Mint/MultiTOS) (2 MB)
Atari Falcon (TOS 4.0x) (4 MB)
Atari Falcon (Mint/MultiTOS) (4 MB)

Thank you for using the ATARI ST-version of UNARJ 9.96 (rev. I_A/Ni!
3.008à) converted by M()ir Brandts Honk/Insh_Allah/Mr Ni!(the Great)

For more info call MBH @ +31-70-3457929 / +31-70-3401215 / +31-070-3452981
or e-mail Insh_Allah: i_a@mbh.org

